%main

boundary = zeros(6,1);

boundary(1) = 0;
boundary(2) = 10;
boundary(3) = 13;
boundary(4) = 17;
boundary(5) = 21;
boundary(6) = 31;

nmin = 3.2755;
nmax = 3.2825;
n1 = 3.2755;
n2 = 3.2825;
n3 = 3.2755;
n4 = 3.2825;
n5 = 3.2755;
k0 = 2.*pi/1.55;

index = nmin:0.01:nmax;

len = length(index);
value = zeros(len,1);

for i =1:len
  N_eff = index(i);
  res = find_last(k0,N_eff,n1,n2,n3,n4,n5,boundary);
      
  if i == 1
     prev = res;
  else
     if prev.*res<=0
        break
     else
        prev = res;
     end
  end   
end
index2 = index(i-1):0.001:index(i);
len_2 = length(index2);

for i =1:len_2
  N_eff = index2(i);
  res = find_last(k0,N_eff,n1,n2,n3,n4,n5,boundary);
      
  if i == 1
     prev = res;
  else
     if prev.*res<=0
        break
     else
        prev = res;
     end
  end   
end

index3 = index2(i-1):0.0001:index2(i);
len_3 = length(index3);

for i =1:len_3
  N_eff = index3(i);
  res = find_last(k0,N_eff,n1,n2,n3,n4,n5,boundary);
      
  if i == 1
     prev = res;
  else
     if prev.*res<=0
        break
     else
        prev = res;
     end
  end   
end

index4 = zeros(1,10);
for k = 1:10
   index4(k) = index3(i-1)+k.*0.00001;
end   
len_4 = length(index4);

for i =1:len_4
  N_eff = index4(i);
  res = find_last(k0,N_eff,n1,n2,n3,n4,n5,boundary);
      
  if i == 1
     prev = res;
  else
     if prev.*res<=0
        break
     else
        prev = res;
     end
  end   
end

format long;
index4(i-1)

N_eff = index4(i-1);
options = odeset('RelTol',1e-6,'AbsTol',[1e-7]);
  eps = n1.^2;
  [T1,Y1] = ode45('wave_eq',[boundary(1) boundary(2)],[0.001; 0.001],[],k0,N_eff,eps);
  len1 = length(Y1(:,1));
  
  eps = n2.^2;
  [T2,Y2] = ode45('wave_eq',[boundary(2) boundary(3)],[Y1(len1,1); Y1(len1,2)],options,k0,N_eff,eps);
  len2 = length(Y2(:,1));

  eps = n3.^2;
  [T3,Y3] = ode45('wave_eq',[boundary(3) boundary(4)],[Y2(len2,1); Y2(len2,2)],options,k0,N_eff,eps);
  len3 = length(Y3(:,1));

  eps = n4.^2;
  [T4,Y4] = ode45('wave_eq',[boundary(4) boundary(5)],[Y3(len3,1); Y3(len3,2)],options,k0,N_eff,eps);
  len4 = length(Y4(:,1));

  eps = n5.^2;
  [T5,Y5] = ode45('wave_eq',[boundary(5) boundary(6)],[Y4(len4,1); Y4(len4,2)],options,k0,N_eff,eps);
  len5 = length(Y5(:,1));
  
maxim = max(Y4(:,1))./n4;
Y1 = Y1./maxim;
Y2 = Y2./maxim;
Y3 = Y3./maxim;
Y4 = Y4./maxim;
Y5 = Y5./maxim;
    
plot(T1,Y1(:,1),T2,Y2(:,1),T3,Y3(:,1),T4,Y4(:,1),T5,Y5(:,1),T1,n1,T2,n2,T3,n3,T4,n4,T5,n5);
title(strcat('Transverse Mode Shape and Refractive Index Profile n_{eff} = ',num2str(index4(i-1),6)));

