clear variables
format long


lambdarange = [1.55];
order = 0;
WGthick = [1050];
WGmatx = [.7114];
WGmaty = [.6112];


guide.thick.horz = [45000,30000,45000];
guide.point.horz = [30,60,30];
guide.point.vert = [20,30,5,5,5,5,5,5,5,5,5,5,5,5,5,10,20,20,10];

nefftotal = [];
confinetotal = [];

for i = 1:length(WGmatx)
    confine = [];
    for j = 1:length(WGthick)
        guide.thick.vert = [20000,3200,150,80,65,80,65,80,65,80,65,80,65 ...
                80,65,80,250,15000,5000];
        InP = InGaAsPindex(1,0,lambdarange);
        WaG = InGaAsPindex(WGmatx(i),WGmaty(i),lambdarange);
        Bar = InGaAsPindex(.735,.513,lambdarange);
        QWs = InGaAsPindex(.735,.835,lambdarange);
        SCH = InGaAsPindex(.767,.504,lambdarange);
        %Bar = InGaAsPindex(.7495,.720,lambdarange);
        %QWs = InGaAsPindex(.7495,.580,lambdarange);
        
        guide.index = [ ...
                1.000,1.000,1.000; ...
                1.0,InP,1.0; ...
                SCH,SCH,SCH; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                QWs,QWs,QWs; ...
                Bar,Bar,Bar; ...
                InP,InP,InP; ...
                WaG,WaG,WaG; ...
                InP,InP,InP; ...
            ];
        
        guide.index = flipud(fliplr(guide.index));
        
        [x,y,mode,neff] = WaveG2D(guide,lambdarange*1e4,order);
        nefftotal = [nefftotal,neff];
        [n] = WaveIndex2D(x,y,guide);
        confine = [confine,modevolume(x,y,mode.*(n==QWs))./modevolume(x,y,mode)];
        
        ['Innerloop ',num2str(i),'  Outerloop ',num2str(j)];
    end
    confinetotal = [confinetotal;confine]
end

mode=mode;

v1 = .9.*max(max(abs(mode)));
v2 = .8.*max(max(abs(mode)));
v3 = .7.*max(max(abs(mode)));
v4 = .6.*max(max(abs(mode)));
v5 = .5.*max(max(abs(mode)));
v6 = .4.*max(max(abs(mode)));
v7 = .3.*max(max(abs(mode)));
v8 = .2.*max(max(abs(mode)));
v9 = .1.*max(max(abs(mode)));

figure(1)
h=surf(x./10000,y./10000,mode)
view(0, 90)
shading interp
formatfig(h)
xlabel('Lateral Waveguide Position (\mum)')
ylabel('Vertical Waveguide Position (\mum)')
axis([-4.5 4.5 -2 2])



figure(2)
h=contour3(x./10000,y./10000,n, 40)
grid
% formatfig(h)
hold 
h= contour(x./10000,y./10000,mode)%, [v1 v2 v3 v4 v5 v6 v7 v8 v9])
% formatfig(h)
view(0, 90)
shading interp



xlabel('Lateral Waveguide Position (\mum)')
ylabel('Vertical Waveguide Position (\mum)')
axis([-4.5 4.5 -2 2])

confinetotal
