from sys import *
import numpy as np
import math
from pylab import *
import matplotlib.pyplot as plt

Ith0 = 21.387/1000 #mA
etad0 = 0.442
Imax = 180.0/1000 #mA
hnuq = 0.85
numpoints = 100
T0 = 50.0
T0d = 103.0
Rs = 10.0
Vd = 0.90
Zt = 68

IT1 = 0
IT2 = 0
IT3 = 0
IT4 = 0
etad1 = 0
etad2 = 0
etad3 = 0
etad4 = 0

#new threshold
tolerance = 0.00005 #tolerance for computed power out
delta = 0.000005
Ith1 = Ith0*1.1
Ith2 = Ith0
while abs(Ith1-Ith2)>tolerance:
    Pd = Ith1**2*Rs+Ith1*Vd
    dT = Pd*Zt
    Ith2 = Ith0*math.exp(dT/T0)
#    print 'Ith1=',Ith1*1000,'Ith2=',Ith2        
    if Ith2>Ith1:
        Ith1=Ith1+delta
    else:
        Ith1=Ith1-delta

I = linspace(0,Imax,numpoints)
Po = zeros(numpoints,float)
Poideal = zeros(numpoints,float)
Ith = zeros(numpoints,float)
etad = zeros(numpoints,float)

PT1 = zeros(numpoints,float)
PT2 = zeros(numpoints,float)
PT3 = zeros(numpoints,float)
PT3 = zeros(numpoints,float)
dT = zeros(numpoints,float)

tolerance = 0.0001 #tolerance for computed power out
Poc = 0.0 #start value for power out

for i in range(0,numpoints):
    if (I[i]<Ith0):
        #Poideal[i]= hnuq*etad0*(I[i]-Ith0)*10**(-4)*0.7#beta spontaneous and radiative efficiency
        Pd = I[i]**2*Rs+I[i]*Vd-Poc
        dT[i] = Pd*Zt
    if (I[i]>=Ith0) and (I[i]<Ith2):
        Poideal[i]= hnuq*etad0*(I[i]-Ith0)
        Pd = I[i]**2*Rs+I[i]*Vd-Poc
        dT[i] = Pd*Zt
    if I[i]>=Ith2:
        Pd = I[i]**2*Rs+I[i]*Vd-Poc
        dT[i] = Pd*Zt
        Ith2 = Ith0*math.exp(dT[i]/T0)
        etad[i] = etad0*math.exp(-dT[i]/T0d)
        Po[i] = hnuq*etad[i]*(I[i]-Ith2)
        Poideal[i]= hnuq*etad0*(I[i]-Ith0)
    while (Po[i]-Poc)>tolerance:
        Poc = Po[i]
        Pd = I[i]**2*Rs+I[i]*Vd-Poc
        dT[i] = Pd*Zt
        Ith2 = Ith0*math.exp(dT[i]/T0)
        etad[i] = etad0*math.exp(-dT[i]/T0d)
        Po[i] = hnuq*etad[i]*(I[i]-Ith2)
    Ith[i] = Ith2




clf()
#conversion into mW
I = I*1000
Po= Po*1000
Imax = Imax*1000
Poideal = Poideal*1000

fig3 = plt.figure(3)
ax3 = fig3.add_subplot(111)
line3 = ax3.plot(I, etad*1000, 'b', linewidth = 3)
ax3.set_ylabel('$\Delta T (\circ C)$', fontsize = 16, color='b')
ax3.set_xlabel('Laser Current (mA)',fontsize = 16)
for tl in ax3.get_yticklabels():
    tl.set_color('b')
    tl.set_fontsize(16)
for tl in ax3.get_xticklabels():
    tl.set_fontsize(16)

majorLocator   = MultipleLocator(15)
majorFormatter = FormatStrFormatter('%d')
minorLocator   = MultipleLocator(1)

ax3.xaxis.set_major_locator(majorLocator)
ax3.xaxis.set_major_formatter(majorFormatter)
ax3.xaxis.set_minor_locator(minorLocator)

majorLocator   = MultipleLocator(100)
majorFormatter = FormatStrFormatter('%d')
minorLocator   = MultipleLocator(10)

ax3.yaxis.set_major_locator(majorLocator)
ax3.yaxis.set_major_formatter(majorFormatter)
ax3.yaxis.set_minor_locator(minorLocator)

grid(True)

plt.show()
